package va.main;

import org.apache.commons.cli.*;
import va.util.GreekCalculator;

public class GreekCalculatorMain {

	public static void main(String[] args) {
		Options options = new Options();
		
		Option help = new Option( "help", "print this message" );
		options.addOption(help);
		options.addOption("mapfile", true, "map file with fmv keys");
		options.addOption("fmvfile", true, "fmv file");
		options.addOption("outputfile", true, "output file");
		
		CommandLineParser parser = new PosixParser();			
		
		try {
			CommandLine cmd = parser.parse( options, args);
			if(cmd.hasOption("help")) {
				HelpFormatter formatter = new HelpFormatter();
				formatter.printHelp( "GreekCalculator", options );
			}
			
			String mapfile = "";
			if(cmd.hasOption("mapfile")) {
				mapfile = cmd.getOptionValue("mapfile");
			} else {
				System.out.println("Please input a mapfile");
				return;
			}
			
			String fmvfile = "";
			if(cmd.hasOption("fmvfile")) {
				fmvfile = cmd.getOptionValue("fmvfile");
			} else {
				System.out.println("Please input a fmvfile");
				return;
			}
			
			String outputfile = "";
			if(cmd.hasOption("fmvfile")) {
				outputfile = cmd.getOptionValue("outputfile");
			} else {
				System.out.println("Please input an output file");
				return;
			}
			
			GreekCalculator gc = new GreekCalculator(mapfile, fmvfile, outputfile);
			gc.work();
			
		} catch(Exception ex) {
			ex.printStackTrace();
		}


	}

}
